<?php

namespace XenGenTr\XGTKullaniciAfisSistemi\Option;

use \XF\Option\AbstractOption;

class xgtKullaniciAfisler extends AbstractOption
{
	public static function renderOption(\XF\Entity\Option $option, array $htmlParams)
	{
		$secim = [];
		
		foreach ($option->option_value AS $afisler)
		{
			$secim[] = [
				'afisAdi' => is_string($afisler['afisAdi']) ? $afisler['afisAdi'] : '',
				'afisIkon' => is_string($afisler['afisIkon']) ? $afisler['afisIkon'] : '',
				'afisAp' => is_string($afisler['afisAp']) ? $afisler['afisAp'] : '',
				'afisMetin' => is_string($afisler['afisMetin']) ? $afisler['afisMetin'] : '',
				'afisikonAp' => is_string($afisler['afisikonAp']) ? $afisler['afisikonAp'] : '',
				'afisikonMetin' => is_string($afisler['afisikonMetin']) ? $afisler['afisikonMetin'] : '',
			];
		}

		return self::getTemplate('admin:option_template_xgtKullaniciAfisleri', $option, $htmlParams, [
			'secim' => $secim,
			'nextCounter' => count($secim)
		]);
	}

	public static function verifyOption(array &$values)
	{

		$output = [];

		foreach ($values AS $afisler)
		{
			if (!isset($afisler['afisAdi']) || !isset($afisler['afisIkon']) || !isset($afisler['afisAp']) || !isset($afisler['afisMetin'])  || !isset($afisler['afisikonAp']) || !isset($afisler['afisikonMetin']))
			{
				continue;
			}

			$cache = self::buildAfisCacheValue($afisler['afisAdi'], $afisler['afisIkon'], $afisler['afisAp'], $afisler['afisMetin'], $afisler['afisikonAp'], $afisler['afisikonMetin']);
			if ($cache)
			{
				$output[] = $cache;
			}
		}

		$values = $output;

		return true;
	}

	public static function buildAfisCacheValue($afisAdi, $afisIkon, $afisAp, $afisMetin, $afisikonAp, $afisikonMetin)
	{
		$afisAdi = trim(strval($afisAdi));

		if (preg_match('/[^a-zA-Z0-9_]/', $afisAdi))
		{
		    return false;
		}

		$afisIkon = is_int($afisIkon) ? '' : trim(strval($afisIkon));
		$afisAp = is_int($afisAp) ? '' : trim(strval($afisAp));
		$afisMetin = is_int($afisMetin) ? '' : trim(strval($afisMetin));
		$afisikonAp = is_int($afisikonAp) ? '' : trim(strval($afisikonAp));
		$afisikonMetin = is_int($afisikonMetin) ? '' : trim(strval($afisikonMetin));

		$afisAdiFind = $afisAdi;

		if (!strlen($afisAdiFind))
		{
			return false;
		}

		return [
			'afisAdi' => $afisAdi,
			'afisIkon' => $afisIkon,
			'afisAp' => $afisAp,
			'afisMetin' => $afisMetin,
			'afisikonAp' => $afisikonAp,
			'afisikonMetin' => $afisikonMetin,
		];
	}
}